# -*- coding: utf-8 -*-

#pour mesurer le temps de calcul
import time

#pour mesurer la taille des objets
import sys

#changer le répertoire courant
import os
os.chdir("C:/Users/ricco/Desktop/demo")

#depart
depart = time.perf_counter()

#importer les données
import dask.dataframe as ddf
D = ddf.read_csv("covtype_subset.txt",delimiter="\t",blocksize=14*1024*1024)

#temps de chargement
print("Temps de chargement read_csv (virtuel) = ", time.perf_counter()-depart)

#taille de l'objet
sys.getsizeof(D)

#lister les types
D.dtypes

#nombre d'observations
D.shape

#structure
#D.visualize()

#apprentissage
DApp = D.loc[D.STATUT=="app"].iloc[:,:-1]
DApp.shape

#X et y
XApp = DApp.iloc[:,:-1].values
yApp = DApp.CIBLE

#structure X
#XApp.visualize()

#taille de l'objet
sys.getsizeof(XApp)

#
depart = time.perf_counter()

#regression logistique
from dask_ml.linear_model import LogisticRegression
clf = LogisticRegression()

#pour delayed
from dask import delayed

#modélisation - différée
delayed_fit = delayed(clf.fit)(XApp,yApp)

#voir détail dans les slides
delayed_fit.visualize()

print("Temps de fit (virtuel) = ", time.perf_counter()-depart)

#
depart = time.perf_counter()

#données test
DTest = D.loc[D.STATUT=="test"].iloc[:,:-1]
DTest.shape

#descripteurs des données en test
XTest = DTest.iloc[:,:-1].values

#calcul des scores d'affectation - différé
delayed_scores = delayed(delayed_fit.predict_proba)(XTest)

#voir détail dans les slides
#delayed_scores.visualize()

print("Temps de predict_proba (virtuel) = ", time.perf_counter()-depart)

#
depart = time.perf_counter()

#obtention des scores - lancement effectif du calcul
#%time scores = delayed_scores.compute()
scores = delayed_scores.compute()

print("Temps de compute (REEL >> englobant toutes les étapes) = ", time.perf_counter()-depart)

#affichage
print(scores)

#performances
from sklearn import metrics
#print(DTest.CIBLE)

#charger en mémoire yTest
yTest = DTest.CIBLE.compute()

print("AUC de DASK pour REG.LOGISTIQUE  = ",metrics.roc_auc_score(yTest,scores[:,1]))

